(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@babel/runtime/helpers/slicedToArray'), require('@babel/runtime/helpers/classCallCheck'), require('@babel/runtime/helpers/createClass')) :
    typeof define === 'function' && define.amd ? define(['exports', '@babel/runtime/helpers/slicedToArray', '@babel/runtime/helpers/classCallCheck', '@babel/runtime/helpers/createClass'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.midiFileSlicer = {}, global._slicedToArray, global._classCallCheck, global._createClass));
})(this, (function (exports, _slicedToArray, _classCallCheck, _createClass) { 'use strict';

    var isIMidiSetTempoEvent = function isIMidiSetTempoEvent(event) {
      return event.setTempo !== undefined;
    };

    var MidiFileSlicer = /*#__PURE__*/function () {
      function MidiFileSlicer(_ref) {
        var json = _ref.json;
        _classCallCheck(this, MidiFileSlicer);
        this._json = json;
      }
      return _createClass(MidiFileSlicer, [{
        key: "slice",
        value: function slice(start, end) {
          var _a, _b;
          var endInMicroseconds = end * 1000;
          var events = [];
          var tracks = this._json.tracks;
          var indexOfNextEvents = tracks.map(function () {
            return 0;
          });
          var offsetOfNextEvents = tracks.map(function (_ref2) {
            var _ref3 = _slicedToArray(_ref2, 1),
              delta = _ref3[0].delta;
            return delta;
          });
          var startInMicroseconds = start * 1000;
          var currentOffset = offsetOfNextEvents.reduce(function (min, offset) {
            return Math.min(min, offset);
          }, 0);
          var elapsedMicrosecondsBeforeSetTimeEvent = 0;
          var microsecondsPerQuarter = 500000;
          var nextOffset = Number.POSITIVE_INFINITY;
          var offsetOfSetTimeEvent = 0;
          while (currentOffset < Number.POSITIVE_INFINITY) {
            var offsetInMicroseconds = elapsedMicrosecondsBeforeSetTimeEvent + (currentOffset - offsetOfSetTimeEvent) * microsecondsPerQuarter / this._json.division;
            if (offsetInMicroseconds >= endInMicroseconds) {
              break;
            }
            for (var i = 0; i < tracks.length; i += 1) {
              if (currentOffset === offsetOfNextEvents[i]) {
                var event = tracks[i][indexOfNextEvents[i]];
                if (isIMidiSetTempoEvent(event)) {
                  elapsedMicrosecondsBeforeSetTimeEvent = offsetInMicroseconds;
                  microsecondsPerQuarter = event.setTempo.microsecondsPerQuarter;
                  offsetOfSetTimeEvent = currentOffset;
                }
                if (offsetInMicroseconds >= startInMicroseconds) {
                  events.push({
                    event: event,
                    time: (offsetInMicroseconds - startInMicroseconds) / 1000
                  });
                }
                indexOfNextEvents[i] += 1;
                offsetOfNextEvents[i] = currentOffset + ((_b = (_a = tracks[i][indexOfNextEvents[i]]) === null || _a === void 0 ? void 0 : _a.delta) !== null && _b !== void 0 ? _b : Number.POSITIVE_INFINITY);
              }
              nextOffset = Math.min(nextOffset, offsetOfNextEvents[i]);
            }
            currentOffset = nextOffset;
            nextOffset = Number.POSITIVE_INFINITY;
          }
          return events;
        }
      }]);
    }();

    exports.MidiFileSlicer = MidiFileSlicer;

}));
